// *********************************************************************
//  Created with bc9Basic - BASIC To C/C++ Translator (V) 9.2.4.9 (2016/03/28)
//       The bc9Basic translator (bc9.exe) was compiled with
//                           g++ (tdm64-1) 5.1.0
// ----------------------------------------------------------------------
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with a C++ Compiler
//                           On MS Windows
//                    Using TCLib by Fred Harris
// *********************************************************************
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
#define _X(y) y
#include <windows.h>
#define   x64
#include "TCLib\stdio.h"
#include "TCLib\string.h"
#include "TCLib\stdlib.h"
#include "TCLib\memory.h"
#include "TCLib\malloc.h"
#include "TCLib\tchar.h"
#include "TCLib\Strings.cpp"
extern _X("C") int _fltused = 1;
typedef String fstring;

// NO HEADERS START
#ifndef _WINDOWS_
//<---UNICODE AWARE
typedef _TCHAR *PCHAR, *LPCH, *PCH, *NPSTR, *LPSTR, *PSTR;
typedef unsigned long DWORD, *PDWORD, *LPDWORD;
typedef unsigned int UINT;
//>---UNICODE AWARE
#endif
// NO HEADERS END
// ***************************************************
// Compiler Defines
// ***************************************************
#ifndef __cplusplus
#error A C++ compiler is required
#endif

// *************************************************
//        User's GLOBAL ENUM blocks
// *************************************************

// *************************************************
//            System Defined Constants
// *************************************************

typedef const _TCHAR* ccptr;
#define CCPTR const _TCHAR*
#define cfree free
//<---UNICODE AWARE
typedef char _char;
#define _strlen strlen
//>---UNICODE AWARE
#define EQU ==
#define NOT_USED(x) if(x);
#define CTLHNDL(id) GetDlgItem(hWnd,id)
_TCHAR   *g_cptr_;  // dummy var for not used returns
unsigned int  g_dum1_;  // dummy var for not used returns
#define cSizeOfDefaultString 2048

// *************************************************
//            User Defined Constants
// *************************************************

#define ALI_ERROR_MEMORY 1
#define ALI_ERROR_FNF 2
#define ALI_ERROR_MAPPING 3
#define ALI_INVALID_HANDLE - 1
#define ALI_FILE_TYPE_CLASS struct _ALI_FILE_TYPE*

// *************************************************
//               Standard Prototypes
// *************************************************

void    Pause (void);
// *************************************************
//          User Defined Types, Unions and Classes
// *************************************************


typedef struct _Ali_File_Type
{
    _TCHAR     nm[MAX_PATH];
    int      sz;
    int      isEof;
    void*    pData;
    HANDLE   hSys;
    HANDLE   hFileMapping;
    int      nCharDone;
    int      nLinesDone;
    _char*   pSrc;
} Ali_File_Type, *LPALI_FILE_TYPE;


// *************************************************
//            User Global Variables
// *************************************************

static _TCHAR*   *g_argv;
static int     g_argc;


// *************************************************
//               User Prototypes
// *************************************************

void*   mapThisFile (fstring&, HANDLE&, HANDLE&, int&);
void    UnmapMappedFile (void* , HANDLE&, HANDLE&);
Ali_File_Type* aliOpenFile (fstring&, int&, fstring&);
int     aliLineInput (LPALI_FILE_TYPE, fstring&);
void    aliCloseFile (LPALI_FILE_TYPE);
int     _tmain (void);

// *************************************************
//            User Global Initialized Arrays
// *************************************************



// *************************************************
//                 Runtime Functions
// *************************************************

void Pause(void)
{
    _tprintf(_T("\n%ls\n"), _T("Press any key to continue..."));
    _gettchar();
}



// *************************************************
//       User Subs, Functions and Class Methods
// *************************************************

void* mapThisFile (fstring&  sFileIn, HANDLE&  hSys, HANDLE&  hFileMapping, int&  cbMapping)
{
    HANDLE   hSearch = {0};
    WIN32_FIND_DATA  w32 = {0};
    void*    pIFdata = {0};
    hSearch = FindFirstFile( sFileIn.lpStr(),  &w32);
    if(hSearch != INVALID_HANDLE_VALUE )
    {
        cbMapping = w32.nFileSizeLow;
        CloseHandle(hSearch);
    }
    else
    {
        return 0;
    }
    hSys = CreateFile( sFileIn.lpStr(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if(hSys )
    {
        hFileMapping = CreateFileMapping( hSys, NULL, PAGE_READONLY, NULL, NULL, NULL);
        if(hFileMapping )
        {
            pIFdata = MapViewOfFile( hFileMapping, FILE_MAP_READ, NULL, NULL, NULL);
            return pIFdata;
        }
        else
        {
            CloseHandle(hSys);
            return NULL;
        }
    }
    else
    {
        return NULL;
    }
    return 0;
}


void UnmapMappedFile (void* pIFData, HANDLE&  hSys, HANDLE&  hFileMapping)
{
    UnmapViewOfFile(pIFData);
    CloseHandle(hFileMapping);
    CloseHandle(hSys);
}


Ali_File_Type* aliOpenFile (fstring&  filename, int&  iErr, fstring&  sErr)
{
    LPALI_FILE_TYPE  pFile;
    UINT     uLen = {0};
    WIN32_FIND_DATA  w32 = {0};
    iErr = 0;
    sErr = _T("");
    if(INVALID_HANDLE_VALUE == FindFirstFile(filename.lpStr(), &w32))
    {
        iErr = ALI_ERROR_FNF;
        sErr = _T("Unable to locate file ");
        sErr += filename;
        return 0;
    }
    pFile = new  Ali_File_Type;
    _tcscpy(pFile->nm, filename.lpStr());
    pFile->pData = mapThisFile( filename, pFile->hSys, pFile->hFileMapping, pFile->sz);
    if(pFile->pData == 0 )
    {
        iErr = ALI_ERROR_MAPPING;
        sErr = _T("Unable to map file ");
        sErr += filename;
        delete pFile;
        return 0;
    }
    else
    {
        pFile->nCharDone = 0;
        pFile->nLinesDone = 0;
//<---UNICODE AWARE
        pFile->pSrc = ( char*) pFile->pData;
//>---UNICODE AWARE
        pFile->isEof = FALSE;
        return pFile;
    }
}


int aliLineInput (LPALI_FILE_TYPE  hAli, fstring&  sData)
{
    LPALI_FILE_TYPE  pFile = {0};
    int      bInRecord = {0};
    int      iResult = {0};
    int      iLen = {0};
    _char*   dwStart = {0};
    UINT     uLen = {0};
    pFile = hAli;
    iResult = TRUE;
    bInRecord = FALSE;
    dwStart = 0;
    iLen = 0;
    for(;;)
    {
        if(pFile->nCharDone >= pFile->sz )
        {
            iResult = FALSE;
            pFile->isEof = TRUE;
            goto L1000;
        }
        if(*pFile->pSrc == 10 || *pFile->pSrc == 13 )
        {
            if(bInRecord )
            {
                goto L1000;
            }
            if(*pFile->pSrc == 10 && *(pFile->pSrc + 1) == 13 )
            {
                pFile->pSrc += 2;
                pFile->nCharDone += 2;
                bInRecord = TRUE;
                dwStart = pFile->pSrc;
                iLen++;
                sData = L"";
                return TRUE;
            }
        }
        else // case else
        {
            if(bInRecord )
            {
                iLen++;
            }
            else
            {
                bInRecord = TRUE;
                dwStart = pFile->pSrc;
                iLen++;
            }
        }
        pFile->pSrc++;
        pFile->nCharDone++;
    }
L1000:
    ;
    if(dwStart && iLen > 0 )
    {
        pFile->nLinesDone++;
        wchar_t*  wszTo = new wchar_t[iLen + 1];
        wszTo[iLen] = L'\0';
        MultiByteToWideChar(CP_ACP, 0, (LPCCH)dwStart, -1, wszTo, iLen);
        sData = wszTo;
        delete[] wszTo;
    }
    return iResult;
}


void aliCloseFile (LPALI_FILE_TYPE  hAli)
{
    LPALI_FILE_TYPE  pFile = {0};
    if(hAli )
    {
        pFile = hAli;
        UnmapMappedFile(pFile->pData, pFile->hSys, pFile->hFileMapping);
        delete pFile;
    }
}


int _tmain ()
{
    HANDLE   hFile = {0};
    LPALI_FILE_TYPE  pFile = {0};
    int      iErr = {0};
    fstring  sErr = {0};
    fstring  sFile(_T("MMF3.CPP"));
    fstring  sData = {0};
    pFile = aliOpenFile( sFile, iErr, sErr);
    if(!pFile )
    {
        _tprintf(_T("sErr = %ls\n"), sErr.lpStr());
        Pause();
        return EXIT_FAILURE;
    }
    while(aliLineInput(pFile, sData))
    {
        _tprintf(_T("%ls\n"), sData.lpStr());
    }

    aliCloseFile(pFile);
    Pause();
}



